'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (_ref) {
	var t = _ref.types;


	var replaceFunctionSent = {
		MetaProperty: function MetaProperty(path) {
			var _path$node = path.node;
			var meta = _path$node.meta;
			var property = _path$node.property;

			if (meta.name === 'function' && property.name === 'sent') {
				path.replaceWith(this.FUNCTION_SENT);
				this.replaced = true;
			}
		},
		Function: function Function(path) {
			path.skip();
		}
	};
	var replaceYield = {
		YieldExpression: function YieldExpression(path) {
			path.replaceWith(t.assignmentExpression('=', this.FUNCTION_SENT, path.node));
			path.skip();
		},
		Function: function Function(path) {
			path.skip();
		}
	};

	return {
		inherits: require("babel-plugin-syntax-function-sent"),
		visitor: {
			Program: {
				enter: function enter(path) {
					this.PATCH = path.scope.generateUidIdentifier('patch_function_sent');
					this.FUNCTION_SENT = path.scope.generateUidIdentifier('function_sent');
					this.requirePatch = false;
				},
				exit: function exit(path) {
					if (this.requirePatch) path.unshiftContainer('body', runtime({ PATCH: this.PATCH }));
				}
			},
			Function: {
				exit: function exit(path) {
					if (!path.node.generator) return;
					var ctx = { FUNCTION_SENT: this.FUNCTION_SENT, replaced: false };
					path.traverse(replaceFunctionSent, ctx);
					if (ctx.replaced) {
						path.traverse(replaceYield, ctx);
						path.scope.push({
							kind: 'let',
							id: this.FUNCTION_SENT,
							init: t.yieldExpression()
						});
						if (path.isFunctionExpression()) {
							path.replaceWith(patch({ PATCH: this.PATCH, GENERATOR: path.node }));
						} else if (path.isFunctionDeclaration()) {
							var parent = path.getFunctionParent();
							var patched = patch({ PATCH: this.PATCH, GENERATOR: path.node.id });
							if (t.isProgram(parent)) parent.unshiftContainer('body', patched);else parent.get('body').unshiftContainer('body', patched);
						}
						this.requirePatch = true;
					}
				}
			}
		}
	};
};

var _babelTemplate = require('babel-template');

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var runtime = (0, _babelTemplate2.default)('\nfunction PATCH(g) {\n\tconst proto = g.prototype\n\tproto.next = function next(value) {\n\t\tif (!this._sent) {\n\t\t\tthis._sent = true\n\t\t\tReflect.apply(Reflect.getPrototypeOf(proto).next, this, [value])\n\t\t}\n\t\treturn Reflect.apply(Reflect.getPrototypeOf(proto).next, this, [value])\n\t}\n}\n');
var patch = (0, _babelTemplate2.default)('PATCH(GENERATOR)');
var init = (0, _babelTemplate2.default)('let FUNCTION_SENT = yield');
module.exports = exports['default'];
